Attribute VB_Name = "Module1"
Const GWL_ID = (-12)
Const GW_HWNDNEXT = 2
Const GW_CHILD = 5
Declare Function GetWindow Lib "user32" (ByVal hwnd As Long, ByVal wCmd As Long) As Long
Declare Function SetFocusAPI Lib "user32" Alias "SetForegroundWindow" (ByVal hwnd As Long) As Long
'Declare Function GetWindow Lib "user32" (ByVal Hwnd As Long, ByVal wCmd As Long) As Long
Declare Function GetDesktopWindow Lib "user32" () As Long
Declare Function GetWindowLW Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Declare Function GetClassName Lib "user32" Alias "GetClassNameA" (ByVal hwnd As Long, ByVal lpClassName As String, ByVal nMaxCount As Long) As Long
Public Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long


Public Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long

Dim aTitles() As String
Dim aClasses() As String
Dim aHandles() As Long
Dim nTotalWindows As Long
Dim Rhino_hwnd_found As Integer
Global Rhino_hwnd As Long

Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Public Function Gather(aHandles() As Long, hWndStart As Long, WindowText As String, Classname As String, ID) As Long
    Dim hwnd As Long
    Dim r As Long

    'Hold the number of matching windows:
    Dim sWindowText As String
    Dim sClassname As String
    Dim sID

    Static level As Long        ' Hold the level of recursion:
    Static iFound As Long       ' Hold the number of matching windows:

    ReDim aTitles(0 To 0)
    ReDim aClasses(0 To 0)
    ReDim aHandles(0 To 0)

    ' Initialize if necessary:
    If level = 0 Then iFound = 0
    
    If hWndStart = 0 Then hWndStart = GetDesktopWindow()

    ' Increase recursion counter:
    level = level + 1
    ' Get first child window:
    hwnd = GetWindow(hWndStart, GW_CHILD)
    Do Until hwnd = 0
        DoEvents ' Not necessary
        ' Search children by recursion:
        r = Gather(aHandles(), hwnd, WindowText, Classname, ID)
        ' Get the window text and class name:
        sWindowText = Space(255)
        r = GetWindowText(hwnd, sWindowText, 255)
        sWindowText = Left(sWindowText, r)

        sClassname = Space(255)
        r = GetClassName(hwnd, sClassname, 255)
        sClassname = Left(sClassname, r)

        iFound = iFound + 1

        ReDim Preserve aHandles(0 To iFound)
        aHandles(iFound) = hwnd

        ReDim Preserve aClasses(0 To iFound)
        aClasses(iFound) = sClassname
        ReDim Preserve aTitles(0 To iFound)
        aTitles(iFound) = sWindowText
           Rhino_hwnd_found = 0
        If Mid(UCase(sClassname), 1, 12) = "RHINO PARENT" And Mid(sWindowText, 1, 10) = "Rhinoceros" Then
            Rhino_hwnd = hwnd

            Rhino_hwnd_found = Rhino_hwnd_found + 1
        Exit Do
        End If
        ' Get next child window:
        hwnd = GetWindow(hwnd, GW_HWNDNEXT)
    Loop
   ' Decrement recursion counter:
   level = level - 1
   ' Return the number of windows found:
   Gather = Rhino_hwnd_found ' iFound
End Function

Public Function GetAllWindows(startHwnd As Long) As String
    Dim nFound As Long

    nFound = Gather(aHandles(), startHwnd, "*", "*", Null)

    GetAllWindows = (nFound <> 0)

    nTotalWindows = nFound
End Function

